*! version 1.0.0 2014-02-14 | long freese | spost13 release

//  Select columns/rows by deleting r/c with omitted o. names
//
//  _rm_matrix_noomitted `inputmatrix' row|col "`names'"
//
//      names: optional names of r or c of input matrix

program _rm_matrix_noomitted, sclass

    version 11.2

    args inputmat rowcol names
    tempname omitmat

    * operations below are column based, so transpose for row selectin
    if "`rowcol'"=="row" {
        matrix `inputmat' = `inputmat''
    }
    else if "`rowcol'"=="col" {
        * hold for now
    }
    else {
        di as error "option -row- or -col- must be specified"
        exit
    }

    * use names in matrix if user doesn't provide names
    if "`names'"=="" {
        *local names : colnames `inputmat'
        local names : colfullnames `inputmat'
    }
    else {
        local nnames = wordcount("`names'")
        local ncols = colsof(`inputmat')
        if `nnames'!=`ncols' {
            di as error "# of input names must match # rows/cols of matrix"
            exit
        }
    }
    * later restore names on dimension not being select
    local rnames : rowfullnames `inputmat'

    * create selection matrix
    mata: inputmat = st_matrix(st_local("inputmat"))
    local colN = colsof(`inputmat')
    _ms_omit_info `inputmat'
    matrix `omitmat' = J(1,`colN',1) - r(omit)
    mata: selectmat = st_matrix(st_local("omitmat"))
    mata: newmat = select(inputmat,selectmat)
    mata: st_matrix(st_local("inputmat"),newmat)

    * names for selected columns
    local names_sel ""
    local i = 0
    foreach nm of local names {
        local ++i
        local keep = `omitmat'[1,`i']
        if `keep' local names_sel `names_sel' `nm'
    }

    matrix colnames `inputmat' = `names_sel'
    matrix rownames `inputmat' = `rnames'

    if "`rowcol'"=="row" {
        matrix `inputmat' = `inputmat''
    }

end
exit
