*! version 3.1.0 2014-02-18 | long freese | spost13 release

//   spost examples and datasets

capture program drop spex
program define spex

    //  to have spex search beyond your working directory for data,
    //  enter the path in quotes below with / as the separator.

    local userpath ""

    syntax namelist(id="dataset or command") [, Web User *]

    tokenize "`namelist'"

    * unabbreviate command
    capture _optname , `1'
    local cmddta = r(opt)

    if ("`1'"=="svy") local cmddta "svy"

    if ("`cmddta'"==".") local cmddta = "`1'"

    local default = "web"

    ** SET DIRECTORY WHERE DATA IS STORED

    if "`web'" == "web" | ///
        ("`user'" == "" & "`default'" == "web") {
       local where "http://www.indiana.edu/~jslsoc/stata/spex_data/"
    }

    if "`user'" == "user" | ///
        ("`web'" == "" & "`default'" == "user") {
        local where "`userpath'"
    }

//  syntax if estimation command is specified

    local brm_vars  "lfp k5 k618 age i.wc i.hc lwg inc"
    local brm_varsf "lfp k5 k618 i.agecat i.wc i.hc lwg inc"
    local ord_vars  "warm i.yr89 i.male i.white age ed prst"
    local ord_varsf "warm i.yr89 i.male i.white age i.edcat prst"
    local crm_vars  "art i.fem i.mar kid5 phd ment"
    local crm_varsf "art i.fem i.mar i.phdcat kid5 ment"
    local crm_inf   "i.fem i.mar kid5 phd ment"
    local crm_inff  "i.fem i.mar i.phdcat kid5 ment"

    if "`cmddta'" == "svy" {
        local data svyhrs3
        local precmd1 `"svyset secu [pweight=kwgtr], strata(stratum)"'
        local cmd "svy: logit arthritis male ib3.ed3cat age"
    }

    if "`cmddta'" == "asmprobit" {
        local data travel2
        local cmd "asmprobit choice time invc, case(id) alternatives(mode) `options'"
    }

    if "`cmddta'" == "clogit" {
        local data travel2
        local cmd "clogit choice train bus time invc, group(id) `options'"
    }

    if "`cmddta'" == "cloglog" {
        local data binlfp4
        local cmd "cloglog `brm_vars', `options'"
    }
    if "`cmddta'" == "cloglogf" {
        local data binlfp4
        local cmd "cloglog `brm_varsf', `options'"
    }
    if "`cmddta'" == "cnreg" {
        local data nels_censored2
        local cmd "cnreg testscor bymomed bydaded black hispanic, censored(censor) `options'"
    }

    if "`cmddta'" == "intreg" {
        local data nels_censored2
        local cmd "intreg minscor maxscor bymomed bydaded black hispanic, `options'"
    }

    if "`cmddta'" == "logit" {
        local data binlfp4
        local cmd "logit `brm_vars', `options'"
    }
    if "`cmddta'" == "logitf" {
        local data binlfp4
        local cmd "logit `brm_varsf', `options'"
    }

    if "`cmddta'" == "misschk" {
        local data gsskidvalue2
        *local cmd "misschk year-income91, help"
        local cmd ///
        "misschk age anykids black degree female kidvalue othrrace year income91 income, help gen(m_) dummy"
    }

    if "`cmddta'" == "mlogit" {
        local data nomocc4
        local cmd "mlogit occ i.white ed exper, `options'"
    }
    if "`cmddta'" == "mlogitf" {
        local data nomocc4
        local cmd "mlogit occ i.white i.edcat exper, `options'"
    }

    if "`cmddta'" == "mprobit" {
        local data nomocc4
        local cmd "mprobit occ i.white ed exper, `options'"
    }

    if "`cmddta'" == "nbreg" {
        local data couart4
        local cmd "nbreg `crm_vars', `options'"
    }
    if "`cmddta'" == "nbregf" {
        local data couart4
        local cmd "nbreg `crm_varsf', `options'"
    }

    if "`cmddta'" == "ologit" {
        local data ordwarm4
        local cmd "ologit `ord_vars', `options'"
    }
    if "`cmddta'" == "ologitf" {
        local data ordwarm4
        local cmd "ologit `ord_varsf', `options'"
    }

    if "`cmddta'" == "oprobit" {
        local data ordwarm4
        local cmd "oprobit `ord_vars', `options'"
    }
    if "`cmddta'" == "oprobitf" {
        local data ordwarm4
        local cmd "oprobit `ord_varsf', `options'"
    }

    if "`cmddta'" == "poisson" {
        local data couart4
        local cmd "poisson `crm_vars', `options'"
    }
    if "`cmddta'" == "poissonf" {
        local data couart4
        local cmd "poisson `crm_varsf', `options'"
    }

    if "`cmddta'" == "probit" {
        local data binlfp4
        local cmd "probit `brm_vars', `options'"
    }
    if "`cmddta'" == "probitf" {
        local data binlfp4
        local cmd "probit `brm_varsf', `options'"
    }

    if "`cmddta'" == "regress" | "`cmddta'" == "reg" {
        local data regjob3
        local cmd "regress job i.fem phd ment i.fel art cit, `options'"
    }

    if "`cmddta'" == "rologit" {
        local data wlsrnk
        local precmd1 `"label variable value1 "est""'
        local precmd2 `"label variable value2 "var""'
        local precmd3 `"label variable value3 "aut""'
        local precmd4 `"label variable value4 "sec""'
        local precmd5 "case2alt, yrank(value) case(id) alt(hashi haslo) casevars(fem hn) gen(rank)"
        local cmd "rologit rank est* var* aut* hashi haslo, group(id) reverse"
    }

    if "`cmddta'" == "slogit" {
        local data ordwarm4
        local cmd "slogit `ord_vars', `options'"
    }
    if "`cmddta'" == "slogitf" {
        local data ordwarm4
        local cmd "slogit `ord_varsf', `options'"
    }

    if "`cmddta'" == "tobit" {
        local data tobjob2
        local cmd "tobit jobcen i.fem phd ment i.fel art cit, ll(1)"
    }

    if "`cmddta'" == "zinb" {
        local data couart4
        local cmd "zinb `crm_vars', inf(`crm_inf') `options'"
    }
    if "`cmddta'" == "zinbf" {
        local data couart4
        local cmd "zinb `crm_varsf', inf(`crm_inff') `options'"
    }

    if "`cmddta'" == "zip" {
        local data couart4
        local cmd "zip `crm_vars', inf(`crm_inf') `options'"
    }
    if "`cmddta'" == "zipf" {
        local data couart4
        local cmd "zip `crm_varsf', inf(`crm_inff') `options'"
    }

    if "`cmddta'" == "ztnb" {
        local data couart4
        local cmd "ztnb `crm_vars' if art > 0, `options'"
    }

    if "`cmddta'" == "ztp" {
        local data couart4
        local cmd "ztp `crm_vars' if art > 0, `options'"
    }

    if "`cmddta'" == "ztnbf" {
        local data couart4
        local cmd "ztnb `crm_varsf' if art > 0, `options'"
    }

    if "`cmddta'" == "ztpf" {
        local data couart4
        local cmd "ztp `crm_varsf' if art > 0, `options'"
    }

    if "`cmd'" == "" {
        local data "`cmddta'"
    }

//  local data

    di _n in white `". use "`where'`data'.dta", clear"'
    capture use "`where'`data'", clear
    if _rc != 0 {
         di _n in green "(trying alternate location for file)"
         di _n in white `". sysuse "`data'.dta", clear"'
         capture sysuse `data'.dta, clear
         if _rc != 0 {
              di as err `"program cannot confirm dta file `data' on path `where'"'
              error 999
         }
    }

//  execute command

    * are there commands to be executed before the command?
    local i = 1
    while `"`precmd`i''"' != "" {
        di in white `". `precmd`i''"'
        `precmd`i''
        local i = `i' + 1
    }

    if "`cmd'" != "" {

        if substr("`cmd'", -2, .) == ", " {
            local trim = length("`cmd'") - 2
            local cmd = substr("`cmd'", 1, `trim')
        }

        di _n in white ". `cmd'"
        `cmd'
    }

    * margins command
    if "`mcmd'" != "" {
        di _n in white ". `mcmd'"
        `mcmd'
    }

end

program define _optname, rclass

    version 8

    syntax , [BINlfp4 ORDwarm4 REGress LOGit MLOGit OLOGit NOMocc4]

    foreach d in binlfp4 ordwarm4 regress logit ///
            mlogit ologit nomocc4 {
       if ("``d''"=="`d'") local opt = "`d'"
    }
    return local opt "`opt'"

end
exit

    if "`cmddta'" == "margolm" {
        local data ordwarm4
        local cmd "ologit warm yr89 male white age ed prst, `options'"
        local mcmd "margins, at(age=(20(10)80)) atmeans predict(outcome(1))"
    }
    if "`cmddta'" == "logitq" {
        local data binlfp4
        local cmd "logit lfp k5 k618 c.age c.age#c.age i.(wc hc) lwg inc, vsquish `options'"
    }
    if "`cmddta'" == "probitq" {
        local data binlfp4
        local cmd "probit lfp k5 k618 c.age c.age#c.age i.(wc hc) lwg inc,  `options'"
    }
